/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for manipulating RDS S3 resource type options.
    /// </summary>
    [DataContract(Name = "RdsS3ResourceTypeOptionsForManipulationDto")]
    public partial class RdsS3ResourceTypeOptionsForManipulationDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsS3ResourceTypeOptionsForManipulationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected RdsS3ResourceTypeOptionsForManipulationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsS3ResourceTypeOptionsForManipulationDto" /> class.
        /// </summary>
        /// <param name="quota">quota (required).</param>
        public RdsS3ResourceTypeOptionsForManipulationDto(QuotaForManipulationDto quota = default(QuotaForManipulationDto))
        {
            // to ensure "quota" is required (not null)
            if (quota == null)
            {
                throw new ArgumentNullException("quota is a required property for RdsS3ResourceTypeOptionsForManipulationDto and cannot be null");
            }
            this.Quota = quota;
        }

        /// <summary>
        /// Gets or Sets Quota
        /// </summary>
        [DataMember(Name = "quota", IsRequired = true, EmitDefaultValue = true)]
        public QuotaForManipulationDto Quota { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class RdsS3ResourceTypeOptionsForManipulationDto {\n");
            sb.Append("  Quota: ").Append(Quota).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
